您的位置:首页 > 其它

LeetCode OJ 之 Sliding Window Maximum(滑动窗口的最大值)

2015-07-24 09:23 483 查看


题目:

Given an array nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding
window moves right by one position.

For example,

Given nums = 
[1,3,-1,-3,5,3,6,7]
, and k = 3.
Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
1 [3  -1  -3] 5  3  6  7       3
1  3 [-1  -3  5] 3  6  7       5
1  3  -1 [-3  5  3] 6  7       5
1  3  -1  -3 [5  3  6] 7       6
1  3  -1  -3  5 [3  6  7]      7


Therefore, return the max sliding window as 
[3,3,5,5,6,7]
.

Note: 

You may assume k is always valid, ie: 1 ≤ k ≤ input array's size for non-empty array.

Follow up:

Could you solve it in linear time?


思路:

这里可以使用双端队列,使得队列里的数呈递减趋势,即始终保持队头最大。

如果对头在当前窗口内,则它就是当前窗口的最大值。

如果队头不在当前窗口范围,则删除它。这里队列里存储的不是值,而是值的位置,因为如果存储值的话,无法判断值是否在当前窗口中。


代码:

class Solution {
public:
vector<int> maxSlidingWindow(vector<int>& nums, int k)
{
deque<int> dq;
vector<int> result;
int len = nums.size();

for (int i = 0 ; i < len ; i++)
{
//当前窗口是[i-k+1, i-k+2, ... i-1, i ](i>=k-1时),如果队头不在这个范围内,则丢弃
if (!dq.empty() && dq.front() < i-k+1)
dq.pop_front();

//把队列中小的删掉,保持队列递减
while (!dq.empty() && nums[dq.back()] < nums[i])
dq.pop_back();

dq.push_back(i);

//从k-1开始,每次的队头就是最大值
if (i >= k-1)
result.push_back(nums[dq.front()]);
}
return result;
}

};

上面deque的操作list也都有,可以替换成list。
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: